             #include    <P16F628A.INC>
             LIST        p=16F628A     
             __CONFIG    H'3F10'        
            
              errorlevel  -302              ; suppress message 302 from list file                         
            
Sec           equ         0020h             ;   
Sec0          equ         0021h
Sec1          equ         0022h             ;   
shet_t1       equ         0023h             ;   tmr1
tmp_byte      equ         0024h             ;  
var_tab       equ         0025h             ;  /  UART
nomer         equ         0026h             ;     
regim         equ         0027h             ;   


data_rx       equ         0061h             ; -   UART (  )
                                            ; 15    0070h

tmp_reg       equ         007Ah             ;
flag          equ         007Bh             ;
FSR_temp      equ         007Ch             ;     
FSR_prer      equ         007Dh             ;  
W_temp        equ         007Eh             ;
STATUS_temp   equ         007Fh             ;

#DEFINE       set_hc12    PORTB,0           ; set  hc-12
#DEFINE       knp_1       PORTB,4           ; 1
#DEFINE       knp_2       PORTB,5           ; 2
#DEFINE       led_grn     PORTA,1           ; 
#DEFINE       led_red     PORTA,0           ; 
#DEFINE       led         PORTB,6           ;

;flag,0 -     UART
;flag,1 -       UART,     
;flag,2 -    
;flag,3 -         UART
;flag,4 -       
;flag,5 -       UART

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   4 ,   1 

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h

              movwf       W_temp            ;  STATUS  W
              swapf       STATUS,W
              movwf       STATUS_temp
              clrf        STATUS 
              
              btfsc       PIR1,RCIF         ;    UART
              goto        priem_uart

              btfsc       PIR1,TMR1IF
              goto        prov_tmr1
              goto        exxit_1

priem_uart    movf        FSR,W             ;   FSR,  
              movwf       FSR_temp          ;      
              movf        FSR_prer,W        ;   FSR_prer 
              movwf       FSR               ; FSR

              movf        RCREG,W           ;    USART  
              movwf       INDF              ;   INDF

              btfss       set_hc12          ;    
              goto        otvet             ;  = 0    

              xorlw       .64               ;   
              btfss       STATUS,Z
              goto        rx_5              ;      
              btfsc       flag,1            ;     
              goto        rx_4              ;    
              
              movlw       .3                ;       
              movwf       tmp_byte
              bsf         flag,1            ;         
              goto        rx_4
              

rx_5          btfss       flag,1            ;     
              goto        exxit
              
rx_4          incf        FSR,F
              decfsz      tmp_byte,F        ;    
              goto        exxit

              movlw       data_rx
              movwf       FSR
              bcf         flag,1            ;        
              bsf         flag,0            ;      
              goto        exxit
              


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

otvet         xorlw       0x0A              ;  
              btfss       STATUS,Z
              goto        otv_1
              bsf         flag,0            ;   
              bcf         flag,1            ;        
              movlw       data_rx
              movwf       FSR
              goto        exxit

otv_1         incf        FSR,F
              movlw       data_rx           ;     
              addlw       .15
              movwf       tmp_byte
              movf        FSR,W
              subwf       tmp_byte,W            
              btfsc       STATUS,C
              goto        exxit
              movlw       data_rx
              movwf       FSR
            


exxit         movf        FSR,W             ;   FSR 
              movwf       FSR_prer          ; FSR_prer
              movf        FSR_temp,W         ;   FSR_osn 
              movwf       FSR               ; FSR
              goto        exxit_1

prov_tmr1     decfsz      shet_t1,F
              goto        t_1               
              bsf         flag,2            ;   
              bcf         T1CON,TMR1ON      ; TMR1
              clrf        TMR1L
              clrf        TMR1H
              
t_1           bcf         PIR1,TMR1IF       ;   tmr1
              
exxit_1       swapf       STATUS_temp,W     ;  STATUS  W
              movwf       STATUS
              swapf       W_temp,F
              swapf       W_temp,W
              retfie                        ;   


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         movlw       b'00000001'
              movwf       PORTB             ;    A  B
              clrf        PORTA             ; 
              
              movlw       b'00000111'       ; 
              movwf       CMCON

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00111111'       ;  \  B      
              movwf       TRISB             ;RB0-RB5 -  ,   
 
              movlw       b'11111100'       ;  \  A   
              movwf       TRISA             ;RA0-RA2 -  ,   
             
              movlw       .25               ; UART 9600 / (4 )   
              movwf       SPBRG             ; 
                                            ; 

              movlw       b'00100100'       ;  USART:   
              movwf       TXSTA             ;  USART,
                                            ;   USART: 8- 
                                            ;,                             
              bcf         STATUS,RP0        ; 0-  
                                            
              movlw       b'10010000'       ;  USART:   USART
              movwf       RCSTA             ;   USART: 8- 
                                            ;,  

              movlw       b'00100000'       ;. TMR1 1:4,     
              movwf       T1CON   
              bcf         PIR1,TMR1IF       ;   tmr1
                     
              movlw       data_rx
              movwf       FSR_prer
              clrf        flag              ;  flag   

              bsf         STATUS,RP0        ;   EEPROM
              movlw       0x00
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       regim 
              
              movf        RCREG,W           ;  RCREG
              movf        RCREG,W           ;  RCREG
              bsf         STATUS,RP0        ; 1-  
              bsf         PIE1,RCIE         ;    USART
              bsf         PIE1,TMR1IE       ;   TMR1
              bcf         STATUS,RP0        ; 0- 
              bsf         INTCON,PEIE       ;   
              bsf         INTCON,GIE        ;  

              call        zap_regim         ;     HC-12

son           call        enter_slp         ;    HC-12   
son_1         bcf         led_red           ;
              bcf         led_grn           ;
              bcf         INTCON,GIE        ;  
              bcf         INTCON,RBIF       ;     RB4-RB7
              bsf         INTCON,RBIE       ;    RB4-RB7
              SLEEP

              bcf         INTCON,RBIE       ;    RB4-RB7
              bsf         INTCON,GIE        ;  

met_2         btfsc       knp_1             ;  knp_1
              goto        met_1             ;
              movlw       .1                ;      tmp_reg
              movwf       tmp_reg
              goto        met_4


met_1         btfss       knp_2             ;  knp_2
              goto        met_3              
              call        paus_50           ;  ,   50 
              goto        son_1             ;    son_1 


met_3         movlw       .2                ;      tmp_reg
              movwf       tmp_reg

met_4         call        exit_slp          ;    HC-12
              movlw       .1                ;   
              xorwf       tmp_reg,W
              btfss       STATUS,Z
              goto        met_5
              call        send_knp1         ;     knp1
              goto        met_10
met_5         call        send_knp2         ;     knp2
              goto        met_10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

met_6         movlw       .4                ;    EEPROM
              xorwf       regim,W
              btfss       STATUS,Z
              goto        met_6a            ;   4 (FU4),    met_6a                                                     
              movlw       .20               ;  4 (FU4),    5 
              call        pusk_tmr1
              goto        met_7

met_6a        movlw       .2                ;    EEPROM
              xorwf       regim,W
              btfss       STATUS,Z
              goto        umen_paus         ;   2 (FU2),    umen_paus
              movlw       .12               ;  2 (FU2),    3 
              call        pusk_tmr1
              goto        met_7

umen_paus     movlw       .6                ;   1,5 
              call        pusk_tmr1

met_7         btfsc       knp_1
              goto        met_8
              call        send_knp1         ;     knp1
              btfsc       knp_2
              goto        met_10
              call        send_knp2         ;     knp2
              goto        met_10

met_8         btfsc       knp_2
              goto        met_9
              call        send_knp2         ;     knp2
              btfsc       knp_1
              goto        met_10
              call        send_knp1         ;     knp1
              goto        met_10
              


met_9         btfsc       flag,0            ;   
              call        prov_otvet        ;=1,  ,   

              btfss       flag,2            ;    
              goto        met_7
              goto        son

met_10        movlw       .1                ;   0,25 
              call        pusk_tmr1

met_11        btfsc       flag,0            ;   
              call        prov_otvet        ;=1,  ,   

              btfss       flag,2            ;    
              goto        met_11
              goto        met_6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

prov_otvet    bcf         flag,0            ;     UART
              movlw       data_rx           ;    
              movwf       FSR
              movlw       .64               ;     64 (ascii  - @)
              xorwf       INDF,W
              btfss       STATUS,Z
              return

              incf        FSR,F
              movlw       .79               ;     79 (ascii  - O)
              xorwf       INDF,W
              btfss       STATUS,Z
              return

              incf        FSR,F
              movlw       .78               ;     78 (ascii  - N)
              xorwf       INDF,W
              btfss       STATUS,Z
              goto        prv_otv1
              bcf         led_red           ;    (ascii  - @ON),   
              bsf         led_grn           ;  
              return

prv_otv1      movlw       .70               ;     70 (ascii  - F)
              xorwf       INDF,W
              btfss       STATUS,Z
              return
              bcf         led_grn           ;    (ascii  - @OF),   
              bsf         led_red           ;  
              return
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

send_knp1     movlw        .64              ;   knp1  UART (ascii  - @01)
              call         send_byte
              movlw        .48
              call         send_byte
              movlw        .49
              call         send_byte
              return

send_knp2     movlw        .64              ;   knp2  UART (ascii  - @02)
              call         send_byte
              movlw        .48
              call         send_byte
              movlw        .50
              call         send_byte
              return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

zap_regim     call        set_at            ;     
              bcf         flag,0            ;     UART

              call        kont_hc12         ;      HC-12
              btfsc       flag,5            ;     hc-12
              goto        fu3_rgm0          ;
              call        kont_hc12         ;      HC-12
              btfss       flag,5            ;     hc-12
              goto        err_hc12          ; ,    error

fu3_rgm0      movlw       .3                ;    EEPROM
              xorwf       regim,W
              btfss       STATUS,Z
              goto        fu4_rgm0          ;   3 (FU3),    fu4_rgm0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                                            ;  3 (FU3),  
 
fu3_rgm1      movlw       .103              ;     UART ( 2400 /)
              movwf       tmp_reg

              movlw       .26               ;  AT+FU3
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu3_a2        btfsc       flag,0            ;   
              goto        fu3_a1            ;=1    fu3_a1 
                           
              btfss       flag,2            ;    
              goto        fu3_a2            ;=0,    fu3_a2
              goto        err_hc12          ;=1,   ,    error
       
fu3_a1        bcf         flag,0            ;     UART
              movlw       .26               ;      "OK+FU3"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              
fu3_rgm2      movlw       .49               ;  AT+B2400,  2400 /
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu3_b2        btfsc       flag,0            ;   
              goto        fu3_b1            ;=1    fu3_b1 
                           
              btfss       flag,2            ;    
              goto        fu3_b2            ;=0,    fu3_b2
              goto        err_hc12          ;=1,   ,    error
       
fu3_b1        bcf         flag,0            ;     UART
              movlw       .49               ;      "OK+B2400"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              goto        fu_rgm0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              
fu4_rgm0      movlw       .4                ;    EEPROM
              xorwf       regim,W
              btfss       STATUS,Z
              goto        fu1_rgm0          ;   4 (FU4),    fu1_rgm0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                                            ;  4 (FU4),  
              movlw       .207              ;     UART ( 1200 /)
              movwf       tmp_reg

fu4_rgm1      movlw       .40               ;  AT+B1200,  1200 /
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu4_c2        btfsc       flag,0            ;   
              goto        fu4_c1            ;=1    fu4_c1 
                           
              btfss       flag,2            ;    
              goto        fu4_c2            ;=0,    fu4_c2
              goto        err_hc12         ;=1,   ,    error
       
fu4_c1        bcf         flag,0            ;     UART
              movlw       .40               ;      "OK+B1200"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              
fu4_rgm2      movlw       .33               ;  AT+FU4
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu4_d2        btfsc       flag,0            ;   
              goto        fu4_d1            ;=1    fu4_d1 
                           
              btfss       flag,2            ;    
              goto        fu4_d2            ;=0,    fu4_d2
              goto        err_hc12          ;=1,   ,    error
       
fu4_d1        bcf         flag,0            ;     UART
              movlw       .33               ;      "OK+FU4"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              goto        fu_rgm0
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

fu1_rgm0      movlw       .1                ;    EEPROM
              xorwf       regim,W
              btfss       STATUS,Z
              goto        fu2_rgm0          ;   1 (FU1),    fu2_rgm0 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                                            ;  1 (FU1),  
              movlw       .51               ;     UART ( 4800 /)
              movwf       tmp_reg

fu1_rgm1      movlw       .58               ;  AT+B4800,  4800 /
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu1_c2        btfsc       flag,0            ;   
              goto        fu1_c1            ;=1    fu1_c1 
                           
              btfss       flag,2            ;    
              goto        fu1_c2            ;=0,    fu1_c2
              goto        err_hc12          ;=1,   ,    error
       
fu1_c1        bcf         flag,0            ;     UART
              movlw       .58               ;      "OK+B4800"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              
fu1_rgm2      movlw       .12               ;  AT+FU1
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu1_d2        btfsc       flag,0            ;   
              goto        fu1_d1            ;=1    fu1_d1 
                           
              btfss       flag,2            ;    
              goto        fu1_d2            ;=0,    fu1_d2
              goto        err_hc12          ;=1,   ,    error
       
fu1_d1        bcf         flag,0            ;     UART
              movlw       .12               ;      "OK+FU1"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              goto        fu_rgm0
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

fu2_rgm0      movlw       .2                ;    EEPROM
              xorwf       regim,W
              btfss       STATUS,Z
              goto        fu3_rgm1          ;   2 (FU2),    fu3_rgm1 (  FU3  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                                            ;  2 (FU2),  
              movlw       .51               ;     UART ( 4800 /)
              movwf       tmp_reg

fu2_rgm1      movlw       .58               ;  AT+B4800,  4800 /
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu2_c2        btfsc       flag,0            ;   
              goto        fu2_c1            ;=1    fu2_c1 
                           
              btfss       flag,2            ;    
              goto        fu2_c2            ;=0,    fu2_c2
              goto        err_hc12          ;=1,   ,    error
       
fu2_c1        bcf         flag,0            ;     UART
              movlw       .58               ;      "OK+B4800"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              
fu2_rgm2      movlw       .19               ;  AT+FU2
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu2_d2        btfsc       flag,0            ;   
              goto        fu2_d1            ;=1    fu2_d1 
                           
              btfss       flag,2            ;    
              goto        fu2_d2            ;=0,    fu2_d2
              goto        err_hc12          ;=1,   ,    error
       
fu2_d1        bcf         flag,0            ;     UART
              movlw       .19               ;      "OK+FU2"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

fu_rgm0       movlw       .86               ;  AT+P8 (   +20dbm)
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu_e2         btfsc       flag,0            ;   
              goto        fu_e1             ;=1    fu_e1 
                           
              btfss       flag,2            ;    
              goto        fu_e2             ;=0,    fu_e2
              goto        err_hc12          ;=1,   ,    error
       
fu_e1         bcf         flag,0            ;     UART
              movlw       .86               ;      "OK+P8"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              
fu_rgm1       movlw       .92               ;  AT+C001,   001
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

fu_f2         btfsc       flag,0            ;   
              goto        fu_f1             ;=1    fu_f1 
                           
              btfss       flag,2            ;    
              goto        fu_f2             ;=0,    fu_f2
              goto        err_hc12          ;=1,   ,    error
        
fu_f1         bcf         flag,0            ;     UART
              movlw       .92               ;      "OK+C001"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err_hc12          ;=0,  ,    error
              
              bsf         STATUS,RP0        ;    UART
              movf        tmp_reg,W         ;     UART
              movwf       SPBRG             ;
              bcf         STATUS,RP0
   
              call        exit_at           ;     

              bsf         led               ; ,    HC-12
              call        paus_200
              call        paus_200
              call        paus_200
              call        paus_200
              bcf         led
              return

err_hc12      bsf         led
              call        paus_200
              bcf         led
              call        paus_200
              goto        err_hc12

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

kont_hc12     bsf         STATUS,RP0
              movlw       .25               ; UART 9600 / (4 )   
              movwf       SPBRG             ;
              bcf         STATUS,RP0
 
              call        test_mess         ;  /    UART
              btfsc       flag,5            ;     hc-12
              return                        ;   ,   

              bsf         STATUS,RP0
              movlw       .12               ; UART 19200 / (4 )   
              movwf       SPBRG             ;
              bcf         STATUS,RP0
 
              call        test_mess         ;  /    UART
              btfsc       flag,5            ;     hc-12
              return                        ;   ,   

              bsf         STATUS,RP0
              movlw       .51               ; UART 4800 / (4 )   
              movwf       SPBRG             ;
              bcf         STATUS,RP0
 
              call        test_mess         ;  /    UART
              btfsc       flag,5            ;     hc-12
              return                        ;   ,   


              bsf         STATUS,RP0
              movlw       .103              ; UART 2400 / (4 )   
              movwf       SPBRG             ;
              bcf         STATUS,RP0
 
              call        test_mess         ;  /    UART
              btfsc       flag,5            ;     hc-12
              return                        ;   ,   

              bsf         STATUS,RP0
              movlw       .207               ; UART 1200 / (4 )   
              movwf       SPBRG             ;
              bcf         STATUS,RP0
 
              call        test_mess         ;  /    UART
              return                        ;   ,   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

test_mess     movlw       data_rx
              movwf       FSR_prer

test_m        bcf         flag,5            ;     hc-12
              movlw       .0                ;  AT
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

tst_mes2      btfss       flag,0            ;   
              goto        tst_mes1          ;=0    tst_mes1 
              bcf         flag,0            ;=1,  

              movlw       .0                ;      "OK"
              call        sravn_otv
              btfsc       flag,4            ;  
              bsf         flag,5            ;=1,    "OK",      hc-12
              return                        ;=0,   ,   

tst_mes1      btfss       flag,2            ;    
              goto        tst_mes2          ;=0,    tst_mes2
              return                        ;=1,   ,   
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

exit_slp      call        set_at            ;     

              bcf         flag,0            ;   
              call        test_mess         ;   AT
              btfss       flag,5            ;     hc-12 
              goto        err1_hc12         ; ,    err1_hc12

              call        exit_at           ;     
              return

err1_hc12     bsf         led               ; ,   
              call        paus_200
              call        paus_200
              call        paus_200
              call        paus_200
              bcf         led 
              call        paus_200
              call        paus_200
              call        paus_200
              call        paus_200
              goto        err1_hc12
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


enter_slp     call        set_at            ;     

              bcf         flag,0            ;   
              movlw       data_rx           ;     
              movwf       FSR_prer

              movlw       .3                ;  AT+SLEEP
              call        message
              movlw       .1                ;   0,25 
              call        pusk_tmr1

ent_a2        btfsc       flag,0            ;   
              goto        ent_a1            ;=1    ent_a1 
                           
              btfss       flag,2            ;    
              goto        ent_a2            ;=0,    ent_a2
              goto        err1_hc12         ;=1,   ,    error
       
ent_a1        bcf         flag,0            ;     UART
              movlw       .3                ;      "OK+SLEEP"
              call        sravn_otv
              btfss       flag,4            ;  
              goto        err1_hc12         ;=0,  ,    error
              
              call        exit_at           ;     
              return
       
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                                            ;   
set_at        bcf         set_hc12          ;    
              bsf         STATUS,RP0        ; 1-  
              bcf         TRISB,0
              bcf         STATUS,RP0        ; 0-  
              call        paus_50           ; 50 
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                                            ;   
exit_at       bsf         STATUS,RP0        ; 1-  
              bsf         TRISB,0
              bcf         STATUS,RP0        ; 0- 
              bsf         set_hc12          ;       
              call        paus_100          ; 100 
              return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pusk_tmr1     movwf       shet_t1           ;  
              bcf         T1CON,TMR1ON      ; TMR1
              bcf         flag,2            ;   
              clrf        TMR1L
              clrf        TMR1H              
              bcf         PIR1,TMR1IF       ;   tmr1
              bsf         T1CON,TMR1ON      ; TMR1
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                                             ;    USART
send_byte     movwf       TXREG              ;     UART 
              bsf         STATUS,RP0         ;
snd_b1        btfss       TXSTA,TRMT         ;  TRMT    
              goto        snd_b1             ; USART
              bcf         STATUS,RP0
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       USART
      
                      
message       movwf       nomer              ;  AT 
              bcf         flag,3
mess_3        call        table              ;   
              movwf       var_tab
              xorlw       0x0D
              btfss       STATUS,Z
              goto        mess_2
              bsf         flag,3             ;    0x0D
              
mess_2        movf        var_tab,W
              movwf       TXREG              ;      
              bsf         STATUS,RP0         ;   USART
mess_1        btfss       TXSTA,TRMT         ;  TRMT    
              goto        mess_1             ; USART
              bcf         STATUS,RP0           
 
              btfsc       flag,3
              return
              incf        nomer,F            ;  nomer ( )
              goto        mess_3             ;      
                                             ;
              
                                            

table         movlw       high tab          ;    
              movwf       PCLATH            ;
              movf        nomer,W           ;
              addlw       low tab           ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F             ;
 
tab           dt 'A', 'T', 0x0D;                                         ;0     
              dt 'A', 'T', '+', 'S', 'L', 'E', 'E', 'P', 0x0D;           ;3  
              dt 'A', 'T', '+', 'F', 'U', '1', 0x0D;                     ;12
              dt 'A', 'T', '+', 'F', 'U', '2', 0x0D;                     ;19          
              dt 'A', 'T', '+', 'F', 'U', '3', 0x0D;                     ;26       
              dt 'A', 'T', '+', 'F', 'U', '4', 0x0D;                     ;33              
              dt 'A', 'T', '+', 'B', '1', '2', '0', '0', 0x0D;           ;40
              dt 'A', 'T', '+', 'B', '2', '4', '0', '0', 0x0D;           ;49
              dt 'A', 'T', '+', 'B', '4', '8', '0', '0', 0x0D;           ;58
              dt 'A', 'T', '+', 'B', '9', '6', '0', '0', 0x0D;           ;67
              dt 'A', 'T', '+', 'B', '1', '9', '2', '0', '0', 0x0D;      ;76
              dt 'A', 'T', '+', 'P', '8', 0x0D;                          ;86
              dt 'A', 'T', '+', 'C', '0', '0', '1', 0x0D;                ;92



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;     USART    

         
sravn_otv     movwf       nomer
              bcf         flag,4             ;   
              movlw       data_rx            ;    
              movwf       FSR
srav_2        call        table1              ;   
              movwf       var_tab
              xorlw       0x0A
              btfss       STATUS,Z
              goto        srav_1
              bsf         flag,4             ;   
              return

srav_1        movf        var_tab,W
              xorwf       INDF,W
              btfsc       STATUS,Z
              goto        srav_3
              return                         ; , 

srav_3        incf        FSR,F
              incf        nomer,F
              goto        srav_2
        

table1        movlw       high tab1         ;    
              movwf       PCLATH            ;
              movf        nomer,W           ;
              addlw       low tab1          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F             ;
 
tab1          dt 'O', 'K', 0x0A;                                          ;0  
              dt 'O', 'K', '+', 'S', 'L', 'E', 'E', 'P', 0x0A;            ;3   
              dt 'O', 'K', '+', 'F', 'U', '1', 0x0A;                      ;12
              dt 'O', 'K', '+', 'F', 'U', '2', 0x0A;                      ;19
              dt 'O', 'K', '+', 'F', 'U', '3', 0x0A;                      ;26
              dt 'O', 'K', '+', 'F', 'U', '4', 0x0A;                      ;33
              dt 'O', 'K', '+', 'B', '1', '2', '0', '0', 0x0A;            ;40
              dt 'O', 'K', '+', 'B', '2', '4', '0', '0', 0x0A;            ;49
              dt 'O', 'K', '+', 'B', '4', '8', '0', '0', 0x0A;            ;58
              dt 'O', 'K', '+', 'B', '9', '6', '0', '0', 0x0A;            ;67
              dt 'O', 'K', '+', 'B', '1', '9', '2', '0', '0', 0x0A;       ;76
              dt 'O', 'K', '+', 'P', '8', 0x0A;                           ;86
              dt 'O', 'K', '+', 'C', '0', '0', '1', 0x0A;                 ;92
             

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              
paus_50       movlw       .53               ;  40 
              movwf       Sec0
aa2           movlw       .255
              movwf       Sec
aa1           decfsz      Sec,F
              goto        aa1
              decfsz      Sec0,F
              goto        aa2
              return

paus_100      movlw       .106               ;  80 
              movwf       Sec0
ab2           movlw       .255
              movwf       Sec
ab1           decfsz      Sec,F
              goto        ab1
              decfsz      Sec0,F
              goto        ab2
              return
            


        

paus_200      movlw       .4                ;  200
              movwf       Sec
as2           movlw       .65
              movwf       Sec0
as3           movlw       .255
              movwf       Sec1
as1           decfsz      Sec1,F
              goto        as1
              decfsz      Sec0,F
              goto        as3
              decfsz      Sec,F
              goto        as2
              return

              end                         ;  